unit JRBOA_Hook;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Classes;

function InstallHook: Boolean; stdcall;
procedure UninstallHook; stdcall;

implementation

uses
  RegData, WndInfo
  {$IFDEF DEBUG}, SysInfo{$ENDIF DEBUG};

var
  HostWnd: HWND;
  SnapMsg,
  ForwardMsg: UINT;
  CallWndRetHook,
  GetMessageHook: HHOOK;
  Vanish: Boolean;
  Unvanishes: TStrings;
  UnderScroll,
  EmulateTilt: Boolean;
  Modifier: Integer;
  BlinkingMsg: Cardinal;
  CursorPos: TPoint;
{$IFDEF DEBUG}
  ModuleName: string;
{$ENDIF DEBUG}

procedure ReadOption;
var
  Reg: TRegData;
  Names: TStrings;
  i: Integer;
begin
  Reg := TRegData.Create;
  try
    //Variable
    if Reg.OpenKey('Software\ShaggyDog\Jerboa\Variable', True) then
    begin
      HostWnd := Reg.ReadIntDef('HostWnd', 0);
      SnapMsg := Reg.ReadIntDef('SnapMsg', 0);
      ForwardMsg := Reg.ReadIntDef('ForwardMsg', 0);
      Reg.CloseKey;
    end;
    //Indication
    if Reg.OpenKey('Software\ShaggyDog\Jerboa\Indication', True) then
    begin
      Vanish := Reg.ReadBoolDef('Vanish', True);
      if Reg.OpenKeyReadOnly('Unvanish') then
      begin
        Unvanishes.Clear;
        Names := TStringList.Create;
        try
          Reg.GetValueNames(Names);
          for i := 0 to Names.Count - 1 do
            Unvanishes.Add(Reg.ReadString(Names.Strings[i]));
        finally
          Names.Free;
        end;
      end;
      Reg.CloseKey;
    end;
    //Wheel
    if Reg.OpenKey('Software\ShaggyDog\Jerboa\Wheel', True) then
    begin
      if TOSVersion.Check(6, 3) then
        UnderScroll := False
      else
        UnderScroll := Reg.ReadBoolDef('UnderScroll', True);
      EmulateTilt := Reg.ReadBoolDef('EmulateTilt', True);
      Modifier := Reg.ReadIntDef('Modifier', VK_SHIFT);
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
end;

procedure VisibleCursor(Show: Boolean); stdcall;
var
  Info: TCursorInfo;
  Count: Integer;
begin
  Info.cbSize := SizeOf(TCursorInfo);
  GetCursorInfo(Info);
  case Info.flags of
    0: if not Show then Exit;
    1: if Show then Exit;
  else
    Exit; //suppressed or fail
  end;

  repeat
    Count := ShowCursor(Show);
  until Show = (Count >= 0);
end;

function MatchesExceptLst(Wnd: HWND; List: TStrings): Boolean;
var
  i: Integer;
begin
  Result := False;
  for i := 0 to List.Count - 1 do
  begin
    Result := MatchesWindow(Wnd, List.ValueFromIndex[i], List.Names[i]);
    if Result then Break;
  end;
end;

function CallWndRetProc(nCode: Integer; wParam: WPARAM; lParam: PCWPRetStruct): LRESULT; stdcall;
begin
  Result := CallNextHookEx(CallWndRetHook, nCode, wParam, Winapi.Windows.LPARAM(lParam));
  if nCode = HC_ACTION then
  begin
    case lParam.message of
      WM_ACTIVATE:
      begin
        {$IFDEF DEBUG}
        OutputDebugString(PChar(ModuleName + ' - WM_ACTIVATE'));
        {$ENDIF DEBUG}
        VisibleCursor(True);
        BlinkingMsg := lParam.message;

        PostMessage(HostWnd, SnapMsg, lParam.hwnd, lParam.wParam);
      end;
    end;
  end;
end;

function GetMessageProc(nCode: Integer; wParam: WPARAM; lParam: PMsg): LRESULT; stdcall;
var
  Pt: TPoint;
  Modify: Boolean;
begin
  Result := CallNextHookEx(GetMessageHook, nCode, wParam, Winapi.Windows.LPARAM(lParam));
  if (nCode = HC_ACTION) and (wParam = PM_REMOVE) then
  begin
    case lParam.message of
      WM_KEYDOWN:
      begin
        if (lParam.lParam shr 31 = 0) and (lParam.lParam shr 30 = 0) then //L[_EB
        begin
          {$IFDEF DEBUG}
          OutputDebugString(PChar(ModuleName + ' - WM_KEYDOWN'));
          {$ENDIF DEBUG}
          if Vanish and not MatchesExceptLst(GetForegroundWindow, Unvanishes) then
          begin
            VisibleCursor(False);
            BlinkingMsg := lParam.message;
          end;
        end;
      end;
      WM_NCMOUSEMOVE, WM_MOUSEMOVE:
      begin
        //̃L[͓͎ WM_MOUSEMOVE BH
        GetCursorPos(Pt);
        if (CursorPos.X <> Pt.X) and (CursorPos.Y <> Pt.Y) then
        begin
          {$IFDEF DEBUG}
          //OutputDebugString(PChar(ModuleName + ' - WM_MOUSEMOVE'));
          {$ENDIF DEBUG}
          if BlinkingMsg <> lParam.message then
          begin
            VisibleCursor(True);
            BlinkingMsg := lParam.message;
          end;
          CursorPos := Pt;
          PostMessage(HostWnd, ForwardMsg, lParam.message, lParam.wParam);
        end;
      end;
      WM_LBUTTONDOWN..WM_MBUTTONDBLCLK,
      WM_XBUTTONDOWN..WM_XBUTTONDBLCLK:
      begin
        {$IFDEF DEBUG}
        OutputDebugString(PChar(ModuleName + ' - WM_BUTTONCLK'));
        {$ENDIF DEBUG}
        if BlinkingMsg <> lParam.message then
        begin
          VisibleCursor(True);
          BlinkingMsg := lParam.message;
        end;
        PostMessage(HostWnd, ForwardMsg, lParam.message, lParam.wParam);
      end;
      WM_MOUSEWHEEL:
      begin
        {$IFDEF DEBUG}
        Modify := False;
        {$ENDIF DEBUG}
        if EmulateTilt then
        begin
          Modify := GetKeyState(Modifier) < 0;
          if Modify then
          begin
            lParam.message := WM_MOUSEHWHEEL;
            //Win10  Modifier 폜ȂƓ삵Ȃ݂B
            lParam.wParam := MakeWParam(0, HiWord(lParam.wParam));
          end;
        end;
        {$IFDEF DEBUG}
        if Modify then
          OutputDebugString(PChar(ModuleName + ' - WM_MOUSE(H)WHEEL'))
        else
          OutputDebugString(PChar(ModuleName + ' - WM_MOUSEWHEEL'));
        {$ENDIF DEBUG}
        PostMessage(HostWnd, ForwardMsg, lParam.message, lParam.wParam);
        if UnderScroll then
          lParam.message := WM_NULL;
      end;
      WM_MOUSEHWHEEL:
      begin
        {$IFDEF DEBUG}
        OutputDebugString(PChar(ModuleName + ' - WM_MOUSEHWHEEL'));
        {$ENDIF DEBUG}
        PostMessage(HostWnd, ForwardMsg, lParam.message, lParam.wParam);
        if UnderScroll then
          lParam.message := WM_NULL;
      end;
    end;
  end;
end;

function InstallHook: Boolean; stdcall;
var
  ErrorCode: Integer;
begin
  CallWndRetHook := SetWindowsHookEx(WH_CALLWNDPROCRET, @CallWndRetProc, HInstance, 0);
  Result := CallWndRetHook <> 0;
  if Result then
  begin
    GetMessageHook := SetWindowsHookEx(WH_GETMESSAGE, @GetMessageProc, HINstance, 0);
    Result := GetMessageHook <> 0;
  end;
  if not Result then
  begin
    ErrorCode := GetLastError;
    UninstallHook;
    SetLastError(ErrorCode);
  end;
end;

procedure UninstallHook; stdcall;
begin
  VisibleCursor(True);
  UnhookWindowsHookEx(CallWndRetHook);
  UnhookWindowsHookEx(GetMessageHook);
  SendNotifyMessage(HWND_BROADCAST, WM_NULL, 0, 0);
end;

initialization
  BlinkingMsg := WM_NULL;
  GetCursorPos(CursorPos);
  Unvanishes := TStringList.Create;
  ReadOption;
  {$IFDEF DEBUG}
  ModuleName := ExtractFileName(ModuleFileName);
  {$ENDIF DEBUG}

finalization
  Unvanishes.Free;

end.
