unit JRBOA_Find;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Hotkeys;

type
  TWindowFinder = class(TForm)
    ExecuteButton: TButton;
    CancelButton: TButton;
    HotkeyLbl: TLabel;
    HotkeyEdt: TGlobalHotkey;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ExecuteButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
  private
    { Private 錾 }
    FSignalKey: Word;
    procedure InstallHotkey;
    procedure UninstallHotkey;
    procedure WMHotKey(var Message: TWMHotKey); message WM_HOTKEY;
  public
    { Public 錾 }
    WndTitle,
    WndName: string;
  end;

resourcestring
  SFindStart = 'Jn';
  SFindAbort = 'f';

var
  WindowFinder: TWindowFinder;

implementation

{$R *.dfm}

uses
  WndInfo;

const
  SignalID = '{2E3043C6-3848-482A-8476-A1A6B3B41D2A}';

procedure TWindowFinder.FormCreate(Sender: TObject);
begin
  FSignalKey := 0;
  WndTitle := '';
  WndName := '';
end;

procedure TWindowFinder.WMHotKey(var Message: TWMHotKey);
var
  Wnd: HWND;
begin
  if Message.HotKey = FSignalKey then
  begin
    Wnd := GetAncestor(WindowFromPoint(Mouse.CursorPos), GA_ROOTOWNER);
    WndTitle := GetWindowTextStr(Wnd);
    WndName := GetClassNameStr(Wnd);

    UninstallHotkey;
    ModalResult := mrOk;
  end;
end;

procedure TWindowFinder.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  UninstallHotkey;
end;

procedure TWindowFinder.InstallHotkey;
var
  Key,
  Modify: Word;
begin
  UninstallHotkey;

  FSignalKey := GlobalAddAtom(PChar(SignalID));
  if FSignalKey = 0 then
    raise Exception.Create(SysErrorMessage(GetLastError))
  else
  begin
    if HotkeyEdt.HotKey = 0 then
      UninstallHotkey
    else
    begin
      HotKeyToKey(HotkeyEdt.HotKey, Key, Modify);
      if RegisterHotKey(Handle, FSignalKey, Modify, Key) then
        ExecuteButton.Caption := SFindAbort
      else
        raise Exception.Create(SysErrorMessage(GetLastError));
    end;
  end;
end;

procedure TWindowFinder.UninstallHotkey;
begin
  if FSignalKey <> 0 then
  begin
    UnregisterHotKey(Handle, FSignalKey);
    GlobalDeleteAtom(FSignalKey);
    FSignalKey := 0;
  end;
  ExecuteButton.Caption := SFindStart;
end;

procedure TWindowFinder.ExecuteButtonClick(Sender: TObject);
begin
  if FSignalKey = 0 then
    InstallHotkey
  else
    UninstallHotkey;
end;

procedure TWindowFinder.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

end.
