unit JRBOA_Host;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, ShellNotifyIcon,
  System.ImageList, Vcl.ImgList, Vcl.Menus, Vcl.ComCtrls, Hotkeys, NumEdits;

type
  TListView = class(Vcl.ComCtrls.TListView)
  private
    function GetItems: TListItems;
    procedure SetItems(Value: TListItems);
  published
    property Items: TListItems read GetItems write SetItems;
  end;

  TSnapThread = class(TThread)
  private
    { Private 錾 }
    FTarget: HWND;
  protected
    { Protected 錾 }
    procedure Execute; override;
  public
    { Public 錾 }
    constructor Create(ATarget: HWND); virtual;
    destructor Destroy;  override;
  end;

  THostForm = class(TForm)
    OKButton: TButton;
    CancelButton: TButton;
    TrayIcon: TShellNotifyIcon;
    TrayImages: TImageList;
    TrayMenu: TPopupMenu;
    ConfigMnu: TMenuItem;
    PropertyMnu: TMenuItem;
    TrayN1Mnu: TMenuItem;
    HaltMnu: TMenuItem;
    TrayN2Mnu: TMenuItem;
    ExitMnu: TMenuItem;
    OptionPage: TPageControl;
    HotKeyTab: TTabSheet;
    ToDesktopLbl: TLabel;
    ToDesktopEdt: TGlobalHotkey;
    ToDesktopDelBtn: TButton;
    ToForegroundLbl: TLabel;
    ToForegroundEdt: TGlobalHotkey;
    ToForegroundDelBtn: TButton;
    HoppingTab: TTabSheet;
    SnapChk: TCheckBox;
    UnsnapLbl: TLabel;
    UnsnapLst: TListView;
    UnsnapTitleEdt: TEdit;
    UnsnapClassEdt: TEdit;
    UnsnapFindBtn: TButton;
    UnsnapRepBtn: TButton;
    UnsnapAddBtn: TButton;
    UnsnapDelBtn: TButton;
    IndicationTab: TTabSheet;
    VanishChk: TCheckBox;
    UnvanishLbl: TLabel;
    UnvanishLst: TListView;
    UnvanishTitleEdt: TEdit;
    UnvanishClassEdt: TEdit;
    UnvanishFindBtn: TButton;
    UnvanishRepBtn: TButton;
    UnvanishAddBtn: TButton;
    UnvanishDelBtn: TButton;
    XMouseTab: TTabSheet;
    TrackingChk: TCheckBox;
    BringTopChk: TCheckBox;
    ReactionRateLbl: TLabel;
    ReactionRateEdt: TUpDownEdit;
    WheelTab: TTabSheet;
    UnderScrollChk: TCheckBox;
    EmulateTiltChk: TCheckBox;
    ModifierLbl: TLabel;
    ModifierCbx: TComboBox;
    WarningLbl: TLabel;
    PreferencesTab: TTabSheet;
    LanguageLbl: TLabel;
    LanguageCbx: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure ConfigMnuClick(Sender: TObject);
    procedure PropertyMnuClick(Sender: TObject);
    procedure HaltMnuClick(Sender: TObject);
    procedure ExitMnuClick(Sender: TObject);
    procedure HotkeyEdtsChange(Sender: TObject);
    procedure ToDesktopDelBtnClick(Sender: TObject);
    procedure ToForegroundDelBtnClick(Sender: TObject);
    procedure UnsnapLstClick(Sender: TObject);
    procedure UnsnapEdtsChange(Sender: TObject);
    procedure UnsnapFindBtnClick(Sender: TObject);
    procedure UnsnapRepBtnClick(Sender: TObject);
    procedure UnsnapAddBtnClick(Sender: TObject);
    procedure UnsnapDelBtnClick(Sender: TObject);
    procedure UnvanishLstClick(Sender: TObject);
    procedure UnvanishEdtsChange(Sender: TObject);
    procedure UnvanishFindBtnClick(Sender: TObject);
    procedure UnvanishRepBtnClick(Sender: TObject);
    procedure UnvanishAddBtnClick(Sender: TObject);
    procedure UnvanishDelBtnClick(Sender: TObject);
    procedure ReactionRateEdtVerify(Sender: TObject; var AText: string; var APosition: Integer;
      Relation: TNumericallyRelationship);
    procedure LanguageCbxSelect(Sender: TObject);
  private
    { Private 錾 }
    FLanguage: LANGID;
    FSnapMsg,
    FForwardMsg: UINT;
    FToDesktopKey,
    FToForegroundKey: Word;
    Fx64Handle: HWND;
    FMouseState: NativeUInt;
    FSnapper: TSnapThread;
    procedure UpdateOKButton;
    procedure GetXMouseParam;
    procedure SetXMouseParam;
    procedure GetWheelParam;
    procedure SetWheelParam;
    procedure EnumLanguages;
    procedure LoadLanguage(Locale: LANGID);
    procedure ReadOption;
    procedure WriteOption;
    function Assisted: Boolean;
    procedure AssistStart;
    procedure AssistStop;
    procedure SnapperTerminate(Sender: TObject);
    procedure SnapProc(WParam: WPARAM; LParam: LPARAM);
    procedure ForwardProc(WParam: WPARAM; LParam: LPARAM);
    procedure HotKeyProc(WParameter: WPARAM; LParameter: LPARAM);
  protected
    { Protected 錾 }
    procedure WndProc(var Message: TMessage); override;
  public
    { Public 錾 }
  end;

resourcestring
  SCultureName = '{ ({)';
  SLocaleID = '$0411';
  SDuplicateHotkey = 'zbgL[dĂ܂';
  SOutOfReactionTime = 'Ԃ͈(0-30000)Oł';
  SInvalidReactionTime = 'sȔԂł';
  SNotFound = '"%s" ܂';

var
  HostForm: THostForm;

implementation

{$R *.dfm}

uses
  JRBOA_Consts, JRBOA_Find,
  System.UITypes,
  WndInfo, Winapi.MultiMon, RegData, System.IOUtils, System.Masks, MLing, SysInfo, Winapi.ShellAPI;

type
  //Jerboa.dll ֐
  TInstallHook = function: Boolean; stdcall;
  TUninstallHook = procedure; stdcall;

const
  SnapID ='{069180F3-4D10-4259-8467-8BC4830E3F20}';
  ForwardID ='{F2DABE38-A268-484C-9F8E-B06E00DACCAB}';
  ToDesktopID = '{BCD9813D-6662-47E0-80B7-768E5E774AE2}';
  ToForegroundID = '{3E3F1107-9780-4C28-8E6C-17C38495A6D8}';

  //MouseWheelRouting ֘A̒ǉB
  SPI_GETMOUSEWHEELROUTING = $201C;
  SPI_SETMOUSEWHEELROUTING = $201D;
  MOUSEWHEEL_ROUTING_FOCUS = 0;
  MOUSEWHEEL_ROUTING_HYBRID = 2; //MSDN ̐ƂP݂ǁAQȂƓ삵ȂBP𒴂ľLH
  SPIF_INICHANGE = SPIF_UPDATEINIFILE or SPIF_SENDCHANGE;

var
  LibHandle: THandle;
  InstallHook: TInstallHook;
  UninstallHook: TUninstallHook;

{ Routine }

procedure SendDebugString(AText: string; Wnd: HWND);
begin
  OutputDebugString(PChar(
    Format('JRBOA: %s - %d/%s/%s', [AText, Wnd, GetClassNameStr(Wnd), GetWindowTextStr(Wnd)])
  ));
end;

//fXNgbvɌĂEBhE`𓾂B
function ShownFrameRect(Wnd: HWND; var Section: TRect): Boolean;
var
  Rt: TRect;
  Mon: HMONITOR;
  Info: TMonitorInfo;
begin
  Result := False;

  if IsWindowVisible(Wnd) and GetFrameRect(Wnd, Rt) then
  begin
    Mon := MonitorFromWindow(Wnd, MONITOR_DEFAULTTONULL);
    if Mon <> 0 then
    begin
      Info.cbSize := SizeOf(Info);
      if GetMonitorInfo(Mon, @Info) then
        Result := IntersectRect(Section, Rt, Info.rcMonitor);
    end;
  end;
end;

//J[\wEBhEɂ邩B
function CursorInWindow(Wnd: HWND): Boolean;
var
  Rt: TRect;
  Pt: TPoint;
begin
  if ShownFrameRect(Wnd, Rt) and GetCursorPos(Pt) then
    Result := PtInRect(Rt, Pt)
  else
    Result := False;
end;

//J[\EBhE̒SɈړB
procedure SnapCursor(Wnd: HWND);
var
  Rt: TRect;
begin
  if ShownFrameRect(Wnd, Rt) then
  begin
    with Rt.CenterPoint do
      SetCursorPos(X, Y);
  end;
end;

//OXgƈv邩B
function MatchesExceptLst(Wnd: HWND; List: TListItems): Boolean;
var
  i: Integer;
begin
  Result := False;
  for i := 0 to List.Count - 1 do
  begin
    with List.Item[i] do
      Result := MatchesWindow(Wnd, SubItems.Strings[0], Caption);
    if Result then Break;
  end;
end;

{ TListView C }

function TListView.GetItems: TListItems;
begin
  //\ƍXVۗBe[}̕ύXȂǂɑΉłȂ߁AIɍXVB
  HandleNeeded;

  Result := inherited Items;
end;

procedure TListView.SetItems(Value: TListItems);
begin
  HandleNeeded;

  inherited Items := Value;
end;

{ TSnapThread }

constructor TSnapThread.Create(ATarget: HWND);
begin
  FTarget := ATarget;

  inherited Create(False);
  FreeOnTerminate := True;
end;

procedure TSnapThread.Execute;
var
  Wnd: HWND;
  i: Integer;
  TargetID: Cardinal;
begin
  if IsWindow(FTarget) then
  begin
    Wnd := 0;
    for i := 0 to 30 do
    begin
      if not Terminated and (FTarget = GetForegroundWindow) then
      begin
        TargetID := GetWindowThreadProcessId(FTarget, nil);
        if TargetID = GetCurrentThreadId then
          Wnd := GetFocus
        else if AttachThreadInput(GetCurrentThreadId, TargetID, True) then
        begin
          try
            Wnd := GetFocus;
          finally
            AttachThreadInput(GetCurrentThreadId, TargetID, False);
          end;
        end;
        if Wnd = 0 then
          Wnd := FTarget;
        SnapCursor(Wnd);
      end;
      if Terminated or CursorInWindow(Wnd) then Break;

      Sleep(100);
    end;
    {$IFDEF DEBUG}
    if Terminated then
      OutputDebugString(PChar('JRBOA: TSnapThread(Cansel)'))
    else if CursorInWindow(Wnd) then
      SendDebugString('TSnapThread(Success)', Wnd)
    else
      SendDebugString('TSnapThread(Fail)', Wnd);
    {$ENDIF DEBUG}
  end
  else
  begin
    {$IFDEF DEBUG}
    OutputDebugString(PChar('JRBOA: TSnapThread(Except)'));
    {$ENDIF DEBUG}
  end;
end;

destructor TSnapThread.Destroy;
begin

  inherited Destroy;
end;

{ THostForm }

procedure THostForm.UpdateOKButton;
begin
  if (ToDesktopEdt.HotKey > 0) and (ToDesktopEdt.HotKey = ToForegroundEdt.HotKey) then
    WarningLbl.Caption := SDuplicateHotkey
  else if ReactionRateEdt.Relation = nrDisaccord then
    WarningLbl.Caption := SOutOfReactionTime
  else if ReactionRateEdt.Relation = nrNonNumber then
    WarningLbl.Caption := SInvalidReactionTime
  else
    WarningLbl.Caption := '';

  OKButton.Enabled := WarningLbl.Caption = '';
end;

procedure THostForm.GetXMouseParam;
var
  Tracking,
  Zorder: BOOL; //Boolean ƃG[ɂȂB
  Rate: Integer;
begin
  SystemParametersInfo(SPI_GETACTIVEWINDOWTRACKING, 0, @Tracking, 0);
  SystemParametersInfo(SPI_GETACTIVEWNDTRKZORDER, 0, @Zorder, 0);
  SystemParametersInfo(SPI_GETACTIVEWNDTRKTIMEOUT, 0, @Rate, 0);
  TrackingChk.Checked := Tracking;
  BringTopChk.Checked := Zorder;
  ReactionRateEdt.Value := Rate;
end;

procedure THostForm.SetXMouseParam;
var
  Tracking,
  Zorder: BOOL;
  Rate: Integer;
begin
  Tracking := TrackingChk.Checked;
  Zorder := BringTopChk.Checked;
  Rate := ReactionRateEdt.Value;
  SystemParametersInfo(SPI_SETACTIVEWINDOWTRACKING, 0, Pointer(Tracking), SPIF_INICHANGE);
  SystemParametersInfo(SPI_SETACTIVEWNDTRKZORDER, 0, Pointer(Zorder), SPIF_INICHANGE);
  SystemParametersInfo(SPI_SETACTIVEWNDTRKTIMEOUT, 0, Pointer(Rate), SPIF_INICHANGE);
end;

procedure THostForm.GetWheelParam;
var
  Routing: DWORD;
  Reg: TRegData;
begin
  if SystemParametersInfo(SPI_GETMOUSEWHEELROUTING, 0, @Routing, 0) then
    UnderScrollChk.Checked := Routing = MOUSEWHEEL_ROUTING_HYBRID
  else
  begin
    Reg := TRegData.Create;
    try
      if Reg.OpenKey('Software\ShaggyDog\Jerboa\Wheel', True) then
      begin
        UnderScrollChk.Checked := Reg.ReadBoolDef('UnderScroll', True);
        Reg.CloseKey;
      end;
    finally
      Reg.Free;
    end;
  end;
end;

procedure THostForm.SetWheelParam;
var
  Routing: DWORD;
  Reg: TRegData;
begin
  if UnderScrollChk.Checked then
    Routing := MOUSEWHEEL_ROUTING_HYBRID
  else
    Routing := MOUSEWHEEL_ROUTING_FOCUS;
  SystemParametersInfo(SPI_SETMOUSEWHEELROUTING, 0, Pointer(Routing), SPIF_INICHANGE);

  Reg := TRegData.Create;
  try
    if Reg.OpenKey('Software\ShaggyDog\Jerboa\Wheel', True) then
    begin
      Reg.WriteBool('UnderScroll', UnderScrollChk.Checked);
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
end;

procedure THostForm.EnumLanguages;
var
  Mask, FileName: string;
  Files: TStringList;
  ModuleHnd: THandle;
  ID: NativeUInt;
  Culture: string;
  Locale: LANGID;
  Buf: array[0..LOCALE_NAME_MAX_LENGTH - 1] of Char;
begin
  Files := TStringList.Create;
  try
    Mask := ChangeFileExt(ExtractFileName(ParamStr(0)), '.*');
    for FileName in TDirectory.GetFiles(ExtractFileDir(ParamStr(0)), Mask) do
    begin
      if MatchesMask(FileName, '*.exe')
        or MatchesMask(FileName, '*.dll')
        or MatchesMask(FileName, '*.txt') then Continue;

      ModuleHnd := LoadLibraryEx(PChar(FileName), 0, LOAD_LIBRARY_AS_DATAFILE);
      if ModuleHnd <> 0 then
        try
          ID := PResStringRec(@SCultureName)^.Identifier;
          if LoadString(ModuleHnd, ID, Buf, Length(Buf)) > 0 then
          begin
            Culture := string(Buf);

            ID := PResStringRec(@SLocaleID)^.Identifier;
            if LoadString(ModuleHnd, ID, Buf, Length(Buf)) > 0 then
            begin
              Locale := StrToUInt(string(Buf));

              Files.AddObject(Culture, TObject(Locale));
            end;
          end;
        finally
          FreeLibrary(ModuleHnd);
        end;
    end;
    Files.Sort;
    LanguageCbx.Items.Assign(Files);
  finally
    Files.Free;
  end;
  LanguageCbx.ItemIndex := LanguageCbx.Items.IndexOfObject(TObject(FLanguage));
end;

procedure THostForm.LoadLanguage(Locale: LANGID);
begin
  if Locale <> FLanguage then
  begin
    if TranslateRootComponent(Locale) > 0 then
      FLanguage := Locale;
  end;
end;

procedure THostForm.ReadOption;
var
  Reg: TRegData;
  Names, Values: TStrings;
  i: Integer;
  NewItem: TListItem;
begin
  Reg := TRegData.Create;
  try
    //Preferences
    //tH[ď̂ŁAԍŏɍsB
    FLanguage := StrToUInt(SLocaleID);
    if Reg.OpenKey('Software\ShaggyDog\Jerboa\Preferences', True) then
    begin
      LoadLanguage(Reg.ReadIntDef('Language', FLanguage));
      Reg.CloseKey;
    end;
    //HotKey
    if Reg.OpenKey('Software\ShaggyDog\Jerboa\HotKey', True) then
    begin
      ToDesktopEdt.HotKey := Reg.ReadIntDef('ToDesktop', 0);
      ToForegroundEdt.HotKey := Reg.ReadIntDef('ToActiveWnd', 0);
      Reg.CloseKey;
    end;
    //Hopping
    if Reg.OpenKey('Software\ShaggyDog\Jerboa\Hopping', True) then
    begin
      SnapChk.Checked := Reg.ReadBoolDef('Snap', True);
      if Reg.OpenKeyReadOnly('Unsnap') then
      begin
        UnsnapLst.Items.Clear;
        Names := TStringList.Create;
        try
          Reg.GetValueNames(Names);
          Values := TStringList.Create;
          try
            for i := 0 to Names.Count - 1 do
              Values.Add(Reg.ReadString(Names.Strings[i]));
            for i := 0 to Values.Count - 1 do
            begin
              NewItem := UnsnapLst.Items.Add;
              NewItem.Caption := Values.Names[i];
              NewItem.SubItems.Add(Values.ValueFromIndex[i]);
            end;
          finally
            Values.Free;
          end;
        finally
          Names.Free;
        end;
      end;
      Reg.CloseKey;
    end;
    //Indication
    if Reg.OpenKey('Software\ShaggyDog\Jerboa\Indication', True) then
    begin
      VanishChk.Checked := Reg.ReadBoolDef('Vanish', True);
      if Reg.OpenKeyReadOnly('Unvanish') then
      begin
        UnvanishLst.Items.Clear;
        Names := TStringList.Create;
        try
          Reg.GetValueNames(Names);
          Values := TStringList.Create;
          try
            for i := 0 to Names.Count - 1 do
              Values.Add(Reg.ReadString(Names.Strings[i]));
            for i := 0 to Values.Count - 1 do
            begin
              NewItem := UnvanishLst.Items.Add;
              NewItem.Caption := Values.Names[i];
              NewItem.SubItems.Add(Values.ValueFromIndex[i]);
            end;
          finally
            Values.Free;
          end;
        finally
          Names.Free;
        end;
      end;
      Reg.CloseKey;
    end;
    //X-Mouse
    GetXMouseParam;
    //Wheel
    GetWheelParam;
    if Reg.OpenKey('Software\ShaggyDog\Jerboa\Wheel', True) then
    begin
      EmulateTiltChk.Checked := Reg.ReadBoolDef('EmulateTilt', True);
      case Reg.ReadIntDef('Modifier', VK_SHIFT) of
        VK_SHIFT: ModifierCbx.ItemIndex := 0;
        VK_CONTROL: ModifierCbx.ItemIndex := 1;
        VK_MENU: ModifierCbx.ItemIndex := 2;
      else
        ModifierCbx.ItemIndex := 0;
      end;
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
end;

procedure THostForm.WriteOption;
var
  Reg: TRegData;
  i: Integer;
begin
  Reg := TRegData.Create;
  try
    Reg.LazyWrite := False;
    //HotKey
    if Reg.OpenKey('Software\ShaggyDog\Jerboa\HotKey', True) then
    begin
      Reg.WriteInteger('ToDesktop', ToDesktopEdt.HotKey);
      Reg.WriteInteger('ToActiveWnd', ToForegroundEdt.HotKey);
      Reg.CloseKey;
    end;
    //Hopping
    if Reg.OpenKey('Software\ShaggyDog\Jerboa\Hopping', True) then
    begin
      Reg.WriteBool('Snap', SnapChk.Checked);
      if Reg.OpenKey('Unsnap', True) then
      begin
        Reg.ClearValues;
        for i := 0 to UnsnapLst.Items.Count - 1 do
          with UnsnapLst.Items.Item[i] do
            Reg.WriteString(IntToStr(i), Caption + '=' + SubItems.Strings[0]);
      end;
      Reg.CloseKey;
    end;
    //Indication
    if Reg.OpenKey('Software\ShaggyDog\Jerboa\Indication', True) then
    begin
      Reg.WriteBool('Vanish', VanishChk.Checked);
      if Reg.OpenKey('Unvanish', True) then
      begin
        Reg.ClearValues;
        for i := 0 to UnvanishLst.Items.Count - 1 do
          with UnvanishLst.Items.Item[i] do
            Reg.WriteString(IntToStr(i), Caption + '=' + SubItems.Strings[0]);
      end;
      Reg.CloseKey;
    end;
    //X-Mouse
    SetXMouseParam;
    //Wheel
    SetWheelParam;
    if Reg.OpenKey('Software\ShaggyDog\Jerboa\Wheel', True) then
    begin
      Reg.WriteBool('EmulateTilt', EmulateTiltChk.Checked);
      case ModifierCbx.ItemIndex of
        0: Reg.WriteInteger('Modifier', VK_SHIFT);
        1: Reg.WriteInteger('Modifier', VK_CONTROL);
        2: Reg.WriteInteger('Modifier', VK_MENU);
      else
        Reg.WriteInteger('Modifier', 0);
      end;
      Reg.CloseKey;
    end;
    //Preferences
    if Reg.OpenKey('Software\ShaggyDog\Jerboa\Preferences', True) then
    begin
      Reg.WriteInteger('Language', FLanguage);
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
end;

function THostForm.Assisted: Boolean;
begin
  if IsWin64 then
    Result := Fx64Handle <> 0
  else
    Result := FToForegroundKey <> 0;
end;

procedure THostForm.AssistStart;
var
  Key,
  Modify: Word;
  FileName: string;
  Info: TShellExecuteInfo;
begin
  if Assisted then Exit;

  //tbNJn
  LibHandle := LoadLibrary(PChar(ChangeFileExt(ParamStr(0), '.dll')));
  if LibHandle = 0 then
    raise Exception.Create(SysErrorMessage(GetLastError))
  else
  begin
    @InstallHook := GetProcAddress(LibHandle, 'InstallHook');
    if not Assigned(@InstallHook) then
      raise Exception.Create(SysErrorMessage(GetLastError));
    @UninstallHook := GetProcAddress(LibHandle, 'UninstallHook');
    if not Assigned(@UninstallHook) then
      raise Exception.Create(SysErrorMessage(GetLastError));

    if not InstallHook then
      raise Exception.Create(SysErrorMessage(GetLastError));

    {$IFDEF DEBUG}
    OutputDebugString('JRBOA: START - Jerboa.dll');
    {$ENDIF DEBUG}
  end;
  //zbgL[o^
  FToDesktopKey := GlobalAddAtom(PChar(ToDesktopID));
  if FToDesktopKey = 0 then
    raise Exception.Create(SysErrorMessage(GetLastError))
  else
    if ToDesktopEdt.HotKey <> 0 then
    begin
      HotKeyToKey(ToDesktopEdt.HotKey, Key, Modify);
      if not RegisterHotKey(HostForm.Handle, FToDesktopKey, Modify, Key) then
        raise Exception.Create(SysErrorMessage(GetLastError));
    end;
  FToForegroundKey := GlobalAddAtom(PChar(ToForegroundID));
  if FToForegroundKey = 0 then
    raise Exception.Create(SysErrorMessage(GetLastError))
  else
    if ToForegroundEdt.HotKey <> 0 then
    begin
      HotKeyToKey(ToForegroundEdt.HotKey, Key, Modify);
      if not RegisterHotKey(HostForm.Handle, FToForegroundKey, Modify, Key) then
        raise Exception.Create(SysErrorMessage(GetLastError));
    end;
  //x64 N
  if IsWin64 then
  begin
    FileName := ChangeFileExt(ParamStr(0), '.x64.exe');
    if FileExists(FileName) then
    begin
      FillChar(Info, SizeOf(TShellExecuteInfo), 0);
      with Info do begin
        cbSize := SizeOf(Info);
        fMask := SEE_MASK_NOCLOSEPROCESS;
        lpVerb := 'open';
        lpFile := PChar(FileName);
        lpParameters := nil;
        lpDirectory := nil;
        nShow := SW_SHOW;
      end;
      if ShellExecuteEx(@Info) then
      begin
        WaitForInputIdle(Info.hProcess, INFINITE);  //Ô߁B
        Fx64Handle := FindWindowIn(GetProcessId(Info.hProcess), 'TEscortForm', 'Jerboa  (x64)');  //WindowsXP SP1 ȍ~B
        CloseHandle(Info.hProcess);
      end;
    end
    else
      raise EFileNotFoundException.CreateFmt(SNotFound, [FileName]);
  end;

  TrayIcon.IconIndex := 0;
  HaltMnu.Checked := False;
end;

procedure THostForm.AssistStop;
begin
  if Assigned(FSnapper) then
    FSnapper.Terminate;
  if Fx64Handle <> 0 then
  begin
    PostMessage(Fx64Handle, WM_CLOSE, 0, 0);
    Fx64Handle := 0;
  end;
  if LibHandle <> 0 then
  begin
    UninstallHook;
    FreeLibrary(LibHandle);
    LibHandle := 0;

    {$IFDEF DEBUG}
    OutputDebugString('JRBOA: STOP - Jerboa.dll');
    {$ENDIF DEBUG}
  end;
  if FToDesktopKey <> 0 then
  begin
    UnregisterHotKey(HostForm.Handle, FToDesktopKey);
    FToDesktopKey := GlobalDeleteAtom(FToDesktopKey);
  end;
  if FToForegroundKey <> 0 then
  begin
    UnregisterHotKey(HostForm.Handle, FToForegroundKey);
    FToForegroundKey := GlobalDeleteAtom(FToForegroundKey);
  end;

  TrayIcon.IconIndex := 1;
  HaltMnu.Checked := True;
end;

procedure THostForm.FormCreate(Sender: TObject);
var
  Reg: TRegData;
begin
  //
  ReadOption;
  {$IFDEF RELEASE}
  OptionPage.TabIndex := 0;
  {$ENDIF RELEASE}
  Application.ShowMainForm := False;
  TrayIcon.Show;

  FToDesktopKey := 0;
  FToForegroundKey := 0;
  Fx64Handle := 0;
  FMouseState := WM_NULL;
  FSnapper := nil;
  UpdateOKButton;

  FSnapMsg := RegisterWindowMessage(SnapID);
  if FSnapMsg <> 0 then
  begin
    FForwardMsg := RegisterWindowMessage(ForwardID);
    if FForwardMsg <> 0 then
    begin
      Reg := TRegData.Create;
      try
        if Reg.OpenKey('Software\ShaggyDog\Jerboa\Variable', True) then
        begin
          Reg.WriteInteger('HostWnd', Self.Handle);
          Reg.WriteInteger('SnapMsg', FSnapMsg);
          Reg.WriteInteger('ForwardMsg', FForwardMsg);
          Reg.CloseKey;
        end;
      finally
        Reg.Free;
      end;
      if TOSVersion.Check(6) then
      begin
        ChangeWindowMessageFilter(FSnapMsg, MSGFLT_ADD);
        ChangeWindowMessageFilter(FForwardMsg, MSGFLT_ADD);
      end;
      AssistStart;
    end;
  end
  else
    raise Exception.Create(SysErrorMessage(GetLastError));
end;

procedure THostForm.SnapperTerminate(Sender: TObject);
begin
  FSnapper := nil;
end;

procedure THostForm.SnapProc(WParam: WPARAM; LParam: LPARAM);
begin
  //mɂ́AEBhEOŃVXej[|bvAbvȂ񂾂ǁAقɕ@vȂB
  if FMouseState = WM_RBUTTONUP then Exit;

  if Assigned(FSnapper) then
  begin
    FSnapper.Terminate;
    {$IFDEF DEBUG}
    SendDebugString('Snap(Cansel)', WParam);
    {$ENDIF DEBUG}
  end;

  if LOWORD(LParam) <> WA_INACTIVE then
  begin
    if CursorInWindow(WParam) then
    begin
      {$IFDEF DEBUG}
      SendDebugString('Snap(Except)', WParam);
      {$ENDIF DEBUG}
    end
    else if MatchesExceptLst(WParam, UnsnapLst.Items) then
    begin
      {$IFDEF DEBUG}
      SendDebugString('Snap(Except)', WParam);
      {$ENDIF DEBUG}
    end
    else
    begin
      FSnapper := TSnapThread.Create(WParam);
      FSnapper.OnTerminate := SnapperTerminate;
    end;
  end;
end;

procedure THostForm.ForwardProc(WParam: WPARAM; LParam: LPARAM);

  procedure ForwardWheelMsg;
  var
    Wnd: HWND;
    Param: NativeUInt;
  begin
    if UnderScrollChk.Checked and not TOSVersion.Check(6, 3) then
    begin
      Wnd := WindowFromPoint(Mouse.CursorPos);
      Param := MakeLParam(Mouse.CursorPos.X, Mouse.CursorPos.Y);
      SendMessage(Wnd, WParam, LParam, Param);
    end;
  end;

begin
  case WParam of
    WM_MOUSEWHEEL:
    begin
      ForwardWheelMsg;
      {$IFDEF DEBUG}
      SendDebugString('Forward(WHEEL)', WParam);
      {$ENDIF DEBUG}
    end;
    WM_MOUSEHWHEEL:
    begin
      ForwardWheelMsg;
      {$IFDEF DEBUG}
      SendDebugString('Forward(HWHEEL)', WParam);
      {$ENDIF DEBUG}
    end;
  end;

  FMouseState := WParam;
end;

procedure THostForm.HotKeyProc(WParameter: WPARAM; LParameter: LPARAM);
begin
  if WParameter = FToDesktopKey then SnapCursor(GetDesktopWindow)
  else
  if WParameter = FToForegroundKey then SnapCursor(GetForegroundWindow);
end;

procedure THostForm.WndProc(var Message: TMessage);
begin
  inherited WndProc(Message);

  with Message do
  begin
    if Msg = FSnapMsg then SnapProc(WParam, LParam)
    else
    if Msg = FForwardMsg then ForwardProc(WParam, LParam)
    else
    if Msg = WM_HOTKEY then HotKeyProc(WParam, LParam);
  end;
end;

procedure THostForm.FormDestroy(Sender: TObject);
begin
  AssistStop;
end;

procedure THostForm.OKButtonClick(Sender: TObject);
var
  InAssist: Boolean;
begin
  InAssist := Assisted;
  try
    AssistStop;
    SendNotifyMessage(HWND_BROADCAST, WM_NULL, 0, 0);
    WriteOption;
    Hide;
    TrayIcon.Show;
  finally
    if InAssist then AssistStart;
  end;
end;

procedure THostForm.CancelButtonClick(Sender: TObject);
var
  Key,
  Modify: Word;
begin
  if not HaltMnu.Checked then
  begin
    if ToDesktopEdt.Tag <> ToDesktopEdt.HotKey then
    begin
      HotKeyToKey(ToDesktopEdt.Tag, Key, Modify);
      RegisterHotKey(HostForm.Handle, FToDesktopKey, Modify, Key);
    end;
    if ToForegroundEdt.Tag <> ToForegroundEdt.HotKey then
    begin
      HotKeyToKey(ToForegroundEdt.Tag, Key, Modify);
      RegisterHotKey(HostForm.Handle, FToForegroundKey, Modify, Key);
    end;
  end;
  ReadOption;
  Hide;
  TrayIcon.Show;
end;

procedure THostForm.ConfigMnuClick(Sender: TObject);
begin
  GetXMouseParam;
  GetWheelParam;
  EnumLanguages;
  ToDesktopEdt.Tag := ToDesktopEdt.HotKey;
  ToForegroundEdt.Tag := ToForegroundEdt.HotKey;
  TrayIcon.Hide;
  Show;
end;

procedure THostForm.PropertyMnuClick(Sender: TObject);
begin
  ShellExecute(0, nil, 'control.exe', 'mouse', '', SW_SHOW);
end;

procedure THostForm.HaltMnuClick(Sender: TObject);
begin
  if Assisted then
    AssistStop
  else
    AssistStart;
end;

procedure THostForm.ExitMnuClick(Sender: TObject);
begin
  Close;
end;

procedure THostForm.HotkeyEdtsChange(Sender: TObject);
begin
  UpdateOKButton;
end;

procedure THostForm.ToDesktopDelBtnClick(Sender: TObject);
begin
  ToDesktopEdt.ClearHotKey;
  UnregisterHotKey(HostForm.Handle, FToDesktopKey);
end;

procedure THostForm.ToForegroundDelBtnClick(Sender: TObject);
begin
  ToForegroundEdt.ClearHotKey;
  UnregisterHotKey(HostForm.Handle, FToForegroundKey);
end;

procedure THostForm.UnsnapLstClick(Sender: TObject);
begin
  if Assigned(UnsnapLst.Selected) then
  begin
    UnsnapTitleEdt.Text := UnsnapLst.Selected.Caption;
    UnsnapClassEdt.Text := UnsnapLst.Selected.SubItems.Strings[0];
  end
  else
  begin
    UnsnapTitleEdt.Text := '';
    UnsnapClassEdt.Text := '';
  end;
end;

procedure THostForm.UnsnapEdtsChange(Sender: TObject);
var
  Selectable: Boolean;
  Item: TListItem;
begin
  Selectable := (UnsnapTitleEdt.Text <> '') or (UnsnapClassEdt.Text <> '');
  for Item in UnsnapLst.Items do
    if (Item.Caption = UnsnapTitleEdt.Text)
      and (Item.SubItems.Strings[0] = UnsnapClassEdt.Text) then
    begin
      Selectable := False;
      Break;
    end;
  UnsnapRepBtn.Enabled := (UnsnapLst.SelCount <> 0) and Selectable;
  UnsnapAddBtn.Enabled := Selectable;
  UnsnapDelBtn.Enabled := UnsnapLst.SelCount <> 0;
end;

procedure THostForm.UnsnapFindBtnClick(Sender: TObject);
begin
  if WindowFinder.ShowModal = mrOk then
  begin
    UnsnapTitleEdt.Text := WindowFinder.WndTitle;
    UnsnapClassEdt.Text := WindowFinder.WndName;

    SetForegroundWindow(Handle);
  end;
end;

procedure THostForm.UnsnapRepBtnClick(Sender: TObject);
begin
  UnsnapLst.Selected.Caption := UnsnapTitleEdt.Text;
  UnsnapLst.Selected.SubItems.Strings[0] := UnsnapClassEdt.Text;

  UnsnapEdtsChange(Self);
end;

procedure THostForm.UnsnapAddBtnClick(Sender: TObject);
var
  NewItem: TListItem;
begin
  NewItem := UnsnapLst.Items.Add;
  with NewItem do
  begin
    Caption := UnsnapTitleEdt.Text;
    SubItems.Add(UnsnapClassEdt.Text);
  end;
  UnsnapLst.Selected := NewItem;

  UnsnapEdtsChange(Self);
end;

procedure THostForm.UnsnapDelBtnClick(Sender: TObject);
begin
  if Assigned(UnsnapLst.Selected) then
    UnsnapLst.Selected.Delete;

  UnsnapEdtsChange(Self);
end;

procedure THostForm.UnvanishLstClick(Sender: TObject);
begin
  if Assigned(UnvanishLst.Selected) then
  begin
    UnvanishTitleEdt.Text := UnvanishLst.Selected.Caption;
    UnvanishClassEdt.Text := UnvanishLst.Selected.SubItems.Strings[0];
  end
  else
  begin
    UnvanishTitleEdt.Text := '';
    UnvanishClassEdt.Text := '';
  end;
end;

procedure THostForm.UnvanishEdtsChange(Sender: TObject);
var
  Selectable: Boolean;
  Item: TListItem;
begin
  Selectable := (UnvanishTitleEdt.Text <> '') or (UnvanishClassEdt.Text <> '');
  for Item in UnvanishLst.Items do
    if (Item.Caption = UnvanishTitleEdt.Text)
      and (Item.SubItems.Strings[0] = UnvanishClassEdt.Text) then
    begin
      Selectable := False;
      Break;
    end;
  UnvanishRepBtn.Enabled := (UnvanishLst.SelCount <> 0) and Selectable;
  UnvanishAddBtn.Enabled := Selectable;
  UnvanishDelBtn.Enabled := UnvanishLst.SelCount <> 0;
end;

procedure THostForm.UnvanishFindBtnClick(Sender: TObject);
begin
  if WindowFinder.ShowModal = mrOk then
  begin
    UnvanishTitleEdt.Text := WindowFinder.WndTitle;
    UnvanishClassEdt.Text := WindowFinder.WndName;

    SetForegroundWindow(Handle);
  end;
end;

procedure THostForm.UnvanishRepBtnClick(Sender: TObject);
begin
  UnvanishLst.Selected.Caption := UnvanishTitleEdt.Text;
  UnvanishLst.Selected.SubItems.Strings[0] := UnvanishClassEdt.Text;

  UnvanishEdtsChange(Self);
end;

procedure THostForm.UnvanishAddBtnClick(Sender: TObject);
var
  NewItem: TListItem;
begin
  NewItem := UnvanishLst.Items.Add;
  with NewItem do
  begin
    Caption := UnvanishTitleEdt.Text;
    SubItems.Add(UnvanishClassEdt.Text);
  end;
  UnvanishLst.Selected := NewItem;

  UnvanishEdtsChange(Self);
end;

procedure THostForm.UnvanishDelBtnClick(Sender: TObject);
begin
  if Assigned(UnvanishLst.Selected) then
    UnvanishLst.Selected.Delete;

  UnvanishEdtsChange(Self);
end;

procedure THostForm.ReactionRateEdtVerify(Sender: TObject; var AText: string;
  var APosition: Integer; Relation: TNumericallyRelationship);
begin
  UpdateOKButton;
end;

procedure THostForm.LanguageCbxSelect(Sender: TObject);
var
  Locale: LANGID;
begin
  if Assigned(LanguageCbx.Items.Objects[LanguageCbx.ItemIndex]) then
    Locale := LANGID(LanguageCbx.Items.Objects[LanguageCbx.ItemIndex])
  else
    Locale := GetUserDefaultUILanguage;
  if Locale <> FLanguage then
    FLanguage := Locale;
end;

end.
