(* MLing

Ver, 1.00 2019/11/16 ^B

ۉΉCuB

TranslateRootComponent
\[XDLL[hă[gR|[lgiĂ̓tH[jȉ|󂷂B
RichEdit Tvt reinit.LoadNewResourceModule ́B

|̓R|[lg̍ď𔺂߁AvpeB̕ύXׂ͂ăNAB
RAD Studio t̃gX[Vc[XC[ĝ܂܎g邪A
IEUEtC|ɂ͌Ȃ߁ANɕύXprB

  MultiLingual *)

unit MLing;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Classes, Vcl.Controls, Vcl.Forms;

function TranslateRootComponent(FileName: string): THandle; overload;
function TranslateRootComponent(Locale: LCID): THandle; overload;

implementation

{ Routine }

type
  TAsInheritedReader = class(TReader)
  public
    procedure ReadPrefix(var Flags: TFilerFlags; var AChildPos: Integer); override;
  end;

procedure TAsInheritedReader.ReadPrefix(var Flags: TFilerFlags; var AChildPos: Integer);
begin
  inherited ReadPrefix(Flags, AChildPos);
  Include(Flags, ffInherited);
end;

function InternalReloadComponentRes(const ResName: string; HInst: THandle; var Instance: TComponent): Boolean;
var
  HRsrc: THandle;
  ResStream: TResourceStream;
  AsInheritedReader: TAsInheritedReader;
begin                   { avoid possible EResNotFound exception }
  if HInst = 0 then HInst := HInstance;
  HRsrc := FindResource(HInst, PChar(ResName), RT_RCDATA);
  Result := HRsrc <> 0;
  if not Result then Exit;
  ResStream := TResourceStream.Create(HInst, ResName, RT_RCDATA);
  try
    AsInheritedReader := TAsInheritedReader.Create(ResStream, 4096);
    try
      Instance := AsInheritedReader.ReadRootComponent(Instance);
    finally
      AsInheritedReader.Free;
    end;
  finally
    ResStream.Free;
  end;
  Result := True;
end;

function ReloadInheritedComponent(Instance: TComponent; RootAncestor: TClass): Boolean;

  function InitComponent(ClassType: TClass): Boolean;
  begin
    Result := False;
    if (ClassType = TComponent) or (ClassType = RootAncestor) then Exit;
    Result := InitComponent(ClassType.ClassParent);
    Result := InternalReloadComponentRes(ClassType.ClassName, FindResourceHInstance(
      FindClassHInstance(ClassType)), Instance) or Result;
  end;

begin
  Result := InitComponent(Instance.ClassType);
end;

procedure ReinitializeForms;
var
  Count: Integer;
  I: Integer;
  Form: TForm;
begin
  Count := Screen.FormCount;
  for I := 0 to Count - 1 do
  begin
    Form := Screen.Forms[I];
    ReloadInheritedComponent(Form, TForm);
  end;
end;

function SetResourceHInstance(NewInstance: Longint): THandle;
var
  CurModule: PLibModule;
begin
  CurModule := LibModuleList;
  Result := 0;
  while CurModule <> nil do
  begin
    if CurModule.Instance = HInstance then
    begin
      if CurModule.ResInstance <> CurModule.Instance then
        FreeLibrary(CurModule.ResInstance);
      CurModule.ResInstance := NewInstance;
      Result := NewInstance;
      Exit;
    end;
    CurModule := CurModule.Next;
  end;
end;

function TranslateRootComponent(FileName: string): THandle;
var
  NewInst: THandle;
begin
  Result := 0;
  NewInst := LoadLibraryEx(PChar(FileName), 0, LOAD_LIBRARY_AS_DATAFILE);
  if NewInst > 0 then
    Result := SetResourceHInstance(NewInst);
  if Result > 0 then
    ReinitializeForms;
end;

function TranslateRootComponent(Locale: LCID): THandle;
var
  LocaleName: array[0..4] of Char;
  FileName: string;
begin
  Result := 0;
  GetLocaleInfo(Locale, LOCALE_SABBREVLANGNAME, LocaleName, SizeOf(LocaleName));
  if LocaleName[0] <> #0 then
  begin
    // Then look for a potential language/country translation
    FileName := ChangeFileExt(ParamStr(0), '.' + string(LocaleName));
    Result := TranslateRootComponent(FileName);
    if Result = 0 then
    begin
      // Finally look for a language only translation
      LocaleName[2] := #0;
      FileName := ChangeFileExt(ParamStr(0), '.' + string(LocaleName));
      Result := TranslateRootComponent(FileName);
    end;
  end;
end;

(* \[X̖|@vȂ̂ŃRgAEgBႤƏ̂ԂB
TranslateComponents
t@CǂݍŎwR|[lg|󂷂B
System.Classes.ObjectTextToBinary vpeBĐݒpɏ́B

t@C̍\̓eLXg` DFM ƓꂾÃtH[̃t@Cɂ܂Ƃ߂ĂƂłB
`ĂvpeBׂ͂čĐݒ肷̂ŁAύXȂ͂炩ߍ폜ĂƁB
ɁACxgnh͍폜ĂȂƃG[NB
IEUEtC|ɑΉĂ邪AR|[lgĐꂽ̓삪sijB

uses
  System.RTLConsts;

type
  TWriter = class(System.Classes.TWriter);  //veNg\bh΍B

procedure TranslateComponents(const Input: TStream);
var
  FFmtSettings: TFormatSettings;
  Parser: TParser;
  Root: TComponent;

  procedure ConvertObject;
  var
    Output: TMemoryStream;
    Writer: TWriter;
    InheritedObject: Boolean;
    InlineObject: Boolean;
    Instance: TComponent;
    TokenStr, OlgName: string;

    function ConvertOrderModifier: Integer;
    begin
      Result := -1;
      if Parser.Token = '[' then
      begin
        Parser.NextToken;
        Parser.CheckToken(toInteger);
        Result := Parser.TokenInt;
        Parser.NextToken;
        Parser.CheckToken(']');
        Parser.NextToken;
      end;
    end;

    procedure ConvertHeader(IsInherited, IsInline: Boolean);
    var
      ClassName, ObjectName: string;
      Flags: TFilerFlags;
      Position: Integer;
    begin
      Parser.CheckToken(toSymbol);
      ClassName := Parser.TokenString;
      ObjectName := '';
      if Parser.NextToken = ':' then
      begin
        Parser.NextToken;
        Parser.CheckToken(toSymbol);
        ObjectName := ClassName;
        ClassName := Parser.TokenString;
        Parser.NextToken;
      end;

      if Assigned(Root) then
        Instance := Root.FindComponent(ObjectName)
      else
      begin
        Root := Application.FindComponent(ObjectName);
        Instance := Root;
      end;

      if Assigned(Instance) then
      begin
        Flags := [];
        Position := ConvertOrderModifier;
        if IsInherited then
          Include(Flags, ffInherited);
        if IsInline then
          Include(Flags, ffInline);
        if Position >= 0 then
          Include(Flags, ffChildPos);
        Writer.WritePrefix(Flags, Position);
        Writer.WriteUTF8Str(ClassName);
        Writer.WriteUTF8Str(ObjectName);
      end
      else
        Parser.ErrorFmt(SClassNotFound, [ObjectName]);
    end;

    procedure ConvertProperty; forward;

    function CombineString: String;
    begin
      Result := Parser.TokenWideString;
      while Parser.NextToken = '+' do
      begin
        Parser.NextToken;
        if not CharInSet(Parser.Token, [System.Classes.toString, toWString]) then
          Parser.CheckToken(System.Classes.toString);
        Result := Result + Parser.TokenWideString;
      end;
    end;

    procedure ConvertValue;
    var
      Order: Integer;
    begin
      if CharInSet(Parser.Token, [System.Classes.toString, toWString]) then
        Writer.WriteString(CombineString)
      else
      begin
        case Parser.Token of
          toSymbol:
            Writer.WriteIdent(Parser.TokenComponentIdent);
          toInteger:
            Writer.WriteInteger(Parser.TokenInt);
          toFloat:
            begin
              case Parser.FloatType of
                's', 'S': Writer.WriteSingle(Parser.TokenFloat);
                'c', 'C': Writer.WriteCurrency(Parser.TokenFloat / 10000);
                'd', 'D': Writer.WriteDate(Parser.TokenFloat);
              else
                Writer.WriteFloat(Parser.TokenFloat);
              end;
            end;
          '[':
            begin
              Parser.NextToken;
              Writer.WriteValue(vaSet);
              if Parser.Token <> ']' then
                while True do
                begin
                  TokenStr := Parser.TokenString;
                  case Parser.Token of
                    toInteger: begin end;
                    System.Classes.toString,toWString: TokenStr := '#' + IntToStr(Ord(TokenStr.Chars[0]));
                  else
                    Parser.CheckToken(toSymbol);
                  end;
                  Writer.WriteUTF8Str(TokenStr);
                  if Parser.NextToken = ']' then Break;
                  Parser.CheckToken(',');
                  Parser.NextToken;
                end;
              Writer.WriteUTF8Str('');
            end;
          '(':
            begin
              Parser.NextToken;
              Writer.WriteListBegin;
              while Parser.Token <> ')' do ConvertValue;
              Writer.WriteListEnd;
            end;
          '{':
            Writer.WriteBinary(Parser.HexToBinary);
          '<':
            begin
              Parser.NextToken;
              Writer.WriteValue(vaCollection);
              while Parser.Token <> '>' do
              begin
                Parser.CheckTokenSymbol('item');
                Parser.NextToken;
                Order := ConvertOrderModifier;
                if Order <> -1 then Writer.WriteInteger(Order);
                Writer.WriteListBegin;
                while not Parser.TokenSymbolIs('end') do ConvertProperty;
                Writer.WriteListEnd;
                Parser.NextToken;
              end;
              Writer.WriteListEnd;
            end;
        else
          Parser.Error(SInvalidProperty);
        end;
        Parser.NextToken;
      end;
    end;

    procedure ConvertProperty;
    var
      PropName: string;
    begin
      Parser.CheckToken(toSymbol);
      PropName := Parser.TokenString;
      Parser.NextToken;
      while Parser.Token = '.' do
      begin
        Parser.NextToken;
        Parser.CheckToken(toSymbol);
        PropName := PropName + '.' + Parser.TokenString;
        Parser.NextToken;
      end;
      Writer.WriteUTF8Str(PropName);
      Parser.CheckToken('=');
      Parser.NextToken;
      ConvertValue;
    end;

  begin
    Output := TMemoryStream.Create;
    try
      Writer := TWriter.Create(Output, 4096);
      try
        Writer.WriteSignature;

        InheritedObject := False;
        InlineObject := False;
        if Parser.TokenSymbolIs('INHERITED') then
          InheritedObject := True
        else if Parser.TokenSymbolIs('INLINE') then
          InlineObject := True
        else
          Parser.CheckTokenSymbol('OBJECT');
        Parser.NextToken;
        ConvertHeader(InheritedObject, InlineObject);
        while not Parser.TokenSymbolIs('END') and
          not Parser.TokenSymbolIs('OBJECT') and
          not Parser.TokenSymbolIs('INHERITED') and
          not Parser.TokenSymbolIs('INLINE') do
          ConvertProperty;
        Writer.WriteListEnd;
        Writer.WriteListEnd;  //Ō ListEnd KvB
      finally
        Writer.Free;  //ĂȂ Output.ReadComponent 삵ȂB
      end;
      OlgName := Instance.Name; //XV Instance.Name ύX̂ŕۑĂB
      Output.Position := 0;
      Output.ReadComponent(Instance);
      Instance.Name := OlgName;
    finally
      Output.Free;
    end;
    while not Parser.TokenSymbolIs('END') do ConvertObject;
    Parser.NextToken;
  end;

begin
  { Initialize a new TFormatSettings block }
  FFmtSettings := FormatSettings;
  FFmtSettings.DecimalSeparator := '.';

  { Create the parser instance }
  Parser := TParser.Create(Input, FFmtSettings);
  try
    repeat
      Root := nil;
      ConvertObject;
    until Parser.Token = toEOF;
  finally
    Parser.Free;
  end;
end;

*)

end.
